using System;
using System.Runtime.Remoting.Messaging;
using System.Runtime.Remoting.Lifetime;

namespace RemoteObject
{
	public abstract class Test: MarshalByRefObject
	{
		public Test()
		{
		}

		public void Method1()
		{
		}

		public int Method2(int p1)
		{
			return p1;
		}

		public string Method3(string p1)
		{
			return p1;
		}

		public int[] Method4(int[] p1)
		{
			int [] ar = new int[p1.Length];
			p1.CopyTo(ar,0);
			return ar;
		}

		public string[] Method5(string[] p1)
		{
			string [] ar = new string[p1.Length];
			p1.CopyTo(ar,0);
			return ar;
		}
	}

	public abstract class ClientTest: Test
	{
		/*
		public override object InitializeLifetimeService()
		{
			ILease tmp = (ILease)base.InitializeLifetimeService();
			if (tmp.CurrentState == LeaseState.Initial)
			{
				tmp.InitialLeaseTime = TimeSpan.FromSeconds(20);
				tmp.RenewOnCallTime = TimeSpan.FromSeconds(20);
			}
			return tmp;
		}
		*/
	}

	public class TcpBinSingletonTest: Test {}
	public class TcpBinSingleCallTest: Test {}
	public class TcpBinClientTest: ClientTest {}

	public class TcpSoapSingletonTest: Test {}
	public class TcpSoapSingleCallTest: Test {}
	public class TcpSoapClientTest: ClientTest {}

	public class HttpBinSingletonTest: Test {}
	public class HttpBinSingleCallTest: Test {}
	public class HttpBinClientTest: ClientTest {}

	public class HttpSoapSingletonTest: Test {}
	public class HttpSoapSingleCallTest: Test {}
	public class HttpSoapClientTest: ClientTest {}

	public class IISHttpBinSingletonTest: Test {}
	public class IISHttpBinSingleCallTest: Test {}
	public class IISHttpBinClientTest: ClientTest {}

	public class IISHttpSoapSingletonTest: Test {}
	public class IISHttpSoapSingleCallTest: Test {}
	public class IISHttpSoapClientTest: ClientTest {}
}
