// DCOMObject.cpp : Implementation of CDCOMObject

#include "stdafx.h"
#include "atlsafe.h"
#include "DCOMObject.h"


// CDCOMObject

STDMETHODIMP CDCOMObject::Method1(void)
{
	return S_OK;
}

STDMETHODIMP CDCOMObject::Method2(LONG p1,LONG* ret)
{
	*ret = p1;
	return S_OK;
}

STDMETHODIMP CDCOMObject::Method3(BSTR p1,BSTR* ret)
{
	return CComBSTR(p1).CopyTo(ret);
}

STDMETHODIMP CDCOMObject::Method4(VARIANT p1,VARIANT* ret)
{
	CComSafeArray<LONG> sa(p1.parray);
	return CComVariant(sa).Detach(ret);
}

STDMETHODIMP CDCOMObject::Method5(VARIANT p1,VARIANT* ret)
{
	CComSafeArray<BSTR> sa(p1.parray);
	return CComVariant(sa).Detach(ret);
}
